;	M4ADD/ASM
DOTAKE	LD	HL,CMDBUF	;WHERE TO PUT THE TEXT
	LD	B,0		;CHARACTER COUNTER
TAKLOP	LD	DE,TFCB		;FCB FOR TAKE FILE
	LD	A,3		;@GET SVC
	RST	28H		;CALL IT
	JR	NZ,TAKERR	;QUIT ON AN ERROR
	LD	(HL),A		;SAVE THE CHARACTER
	INC	HL		;POINT TO THE NEXT
	INC	B		;ADD TO CHARACTER COUNT
	CP	CR		;IS IT THE END OF A COMMAND?
	JR	Z,TAK020	;GO IF IT IS THE END
	LD	C,A
	LD	A,(TAKLOG)	;IS DISPLAY OF TAKE FILES ON?
	OR	A
	LD	A,C
	CALL	NZ,CONOUT
	JR	TAKLOP
TAK020	RET			;RETURN WITH THE STRING
TAKERR	LD	DE,TFCB		;GET READY TO CLOSE THE FILE
	LD	A,60		;@CLOSE SVC
	RST	28H		;CLOSE THE FILE
	XOR	A		;TURN THE TAKE FLAG OFF
	LD	(TAKFLG),A	;RESET IT
	LD	B,0		;NO CHARACTERS YET
	LD	A,29
	CALL	CONOUT
	LD	DE,(CMPRMP)
	CALL	PRTSTR
	JP	GETSTR		;GET LINE INPUT
GETSTR	LD	A,(TAKFLG)	;ARE WE DOING A TAKE COMMAND?
	OR	A
	JP	NZ,DOTAKE	;IF SO THAN GO FILL BUFFER FROM FILE
	PUSH	HL		;SAVE HL AND DE	
	PUSH	DE		
	LD	A,B		;NUMBER OF CHARS IN BUFFER
	LD	(TEMP4),A	;SAVE THAT NUMBER FOR LATER
GET010	CALL	XKEY		;GET A CHARACTER FROM THE KEYBOARD
	JP	NZ,GETEXT	;ABORT ON A *KI ERROR
	CP	8		;IS IT A BACKSPACE?
	JR	NZ,GET030	;GO IF IT ISN'T
	LD	E,A		;SAVE THE KEY
	LD	A,B		;NUMBER OF CHARS LEFT
	OR	A
	JR	Z,GET010	;IF ZERO AT THE START SO NO BACKSPACE
	DEC	B		;ONE MORE POSSIBLE
	DEC	HL		;NEW END OF BUFFER
	LD	A,E		;CHARACTER TO PRINT
	CALL	CONOUT		;DISPLAY A BACKSPACE
	JR	GET010		;GET A NEW KEY
GET030	CP	CR		;<ENTER> PRESSED?
	JR	Z,GET040	;GO IF SO
	CP	24		;ERASE LINE (<SHIFT> BACKARROW) PRESSED
	JR	NZ,GET036	;JUMP GO IF IT ISN'T
GET035	LD	A,B		;NUMBER LEFT
	OR	A
	JR	Z,GET010	;GO GET A NEW KEY IF ALL ERASED
	LD	A,8		;BACKSPACE
	CALL	CONOUT		;PRINT IT
	DEC	B		;ONE MORE LEFT
	DEC	HL		;BACKUP IN THE BUFFER
	JR	GET035		;KEEP LOOPING
GET036	CP	ESC		;WAS THE KEY ESCAPE?
	JR	Z,GET040	;GO OF IT WAS
	CP	129		;WAS IT F1 (ALSO ESCAPE HERE)
	JR	NZ,GET038	;GO IF IT WASN'T
	LD	A,ESC		;GET AN ESCAPE
	JR	GET040		;JOIN THE CODE FOR EXIT
GET038	CP	128		;WAS IT A BREAK
	JR	Z,GET040	;GO IF IT WAS
	CP	20H		;IGNORE ALL OTHER CONTROLS
	JR	C,GET010	;GET A NEW KEY
GET040	INC	B		;ONE LESS CHARACTER LEFT
	LD	(HL),A		;PUT THE CHARACTER IN THE BUFFER
	JR	NZ,GET050	;WHEN Z IS SET, NO MORE CHARS LEFT
	DEC	B		;SAY WE STILL HAVE ONE
	JR	GET060		;MIGHT BE '?' WHICH IS IGNORED AS LAST
GET050	CP	CR		;IS THE CURRENT KEY <ENTER>?
	JR	Z,GETEXT	;FINISH UP AND EXIT
	CP	ESC		;IS IT ESCAPE?
	JR	Z,GETEXT	;FINISH UP AND EXIT
	CP	128		;IS IT BREAK
	JR	Z,GETEXT	;FINISH UP AND EXIT
	INC	HL		;ONE MORE IN THE BUFFER
	CALL	CONOUT		;PRINT WHAT WAS TYPED
GET060	CP	'?'		;WAS IT A '?' ?
	JP	NZ,GET010	;GET A NEW KEY IF NOT
	LD	A,8		;GET A BACKSPACE
	CALL	CONOUT		;PRINT IT TO REMOVE THE '?'
	DEC	HL		;POINT AT THE '?'
	PUSH	HL		;HL -> IY
	POP	IY
	LD	A,' '		;LOOK FOR A PREVIOUS SPACE
	CP	(IY-1)		;IS THERE ONE BACK THERE
	JR	Z,GETEXT	;THERE IS SO EXIT
	LD	A,B		;ARE WE AT THE START OF THE LINE
	DEC	A
; IF Z IS SET THAN THE CURSOR IS AT HOME ON THE LINE.  NO SPACE WILL
; BE ADDED IN THIS CASE.
	LD	A,' '		;PUT A SPACE ON THE DISPLAY
	CALL	NZ,CONOUT	;PRINT IT
GETEXT	LD	A,B		;GET NUMBER ON THE LINE
	DEC	A
	JR	NZ,GET110	;AT LEAST ONE CHAR ON THE LINE
	PUSH	AF		;PUT AF INTO BC
	POP	BC
	LD	A,(HL)		;WAS '?' THE TERMINATOR?
	CP	'?'
	LD	A,B		;GET THE LENGTH IN A
	JR	NZ,GET120
GET110	INC	A		;COUNT THE TERMINATOR IF IT IS '?'
GET120	LD	B,A		;SAVE THE LENGTH
	LD	A,(HL)		;GET THE TERMINATOR
	CP	ESC		;WAS IT ESC
	JR	Z,GET130	;SKIP SPECIAL CASE HERE
	SLA	A		;CHECK FOR BREAK (128 IS NEGATIVE)
	JR	C,GET130	;ALSO GIVES C STATUS LIKE @KEYIN
	SRL	A		;FIX IT BACK
	OR	10H		;MAKE CR, CHR$(29), '?' IS UNDISTURBED
	CALL	CONOUT		;PRINT THE CHARACTER
GET130	POP	DE		;RESTORE THE REGS
	POP	HL
	RET			;RETURN TO THE CALLER
;
STDOUT	LD	A,16		;REVERSE VIDEO ON
	JP	CONOUT		;USE THE RETURN ON THE STACK
STDEND	LD	A,17		;REVERSE VIDEO OFF
	JP	CONOUT		;USE THE RETURN ON THE STACK
VT52	XOR	A		;RESET THE ESCAPE CHAR FLAG
	LD	(ESCFLG),A
	LD	A,E		;WHAT WAS THE CHARACTER
	CALL	LOGONE		;LOG IT IF NECESSARY
	CP	'A'		;IS IT ONE OF A-Z?
	RET	M		;DON'T NO ANY LESS THAN 'A'
	CP	'I'		;MIGHT BE REVERSE INDEX
	JR	Z,REVIND		;GO DO IT IF SO
	CP	'Y'		;MIGHT BE ROW, COLUMN POSITIONING
	JR	Z,GORC		;GO IF IT IS
	CP	'L'		;WE KNOW UP TO 'M'
	RET	P		;ABORT ALL OTHERS
	SUB	'A'		;MAKE IN BINARY
	RLCA			;TIMES 2
	RLCA			;TIMES 4
	LD	HL,TA		;CONTROL CODE TABLE
	LD	D,0		;MAKE DE A 16 BIT BYTE
	LD	E,A		;DE IS NOW AN OFFSET
	ADD	HL,DE		;HL IS THE ADDRESS OF THE CODE
	EX	DE,HL		;DE IS NOW THE ADDRESS
	CALL	PRTSTR		;PRINT THE CONTROL STRING
	RET
; GOTO ROW, COLUMN POSITION
GORC	CALL	INPORT		;GET THE ROW CHARACTER
	JR	NZ,GORC		;LOOP UNTIL ONE COMES
	CALL	LOGONE		;LOG IT IF NECESSARY
	SUB	32		;MAKE IT A BINARY 0-23
	LD	H,A		;H IS THE ROW FOR @VDCTL CALL
	PUSH	HL
GO010	CALL	INPORT		;GET THE COLUMN CHARACTER
	JR	NZ,GO010	;LOOP UNTIL WE GET ONE
	CALL	LOGONE		;LOG IT IF NECESSARY
	POP	HL
	SUB	32		;MAKE IT BINARY 0-79
	LD	L,A		;L IS COLUMN FOR @VDCTL
	LD	B,3		;SET ROW COLUMN OPTION OF @VDCTL
	LD	A,15		;@VDCTL SVC
	RST	28H		;SET THE NEW ROW AND COLUMN
	RET
;DO A REVERSE INDEX SCROLL	
REVIND	LD	A,15		;MUST TURN THE CURSOR OFF
	CALL	CONOUT		;NOW IT IS OFF
	LD	B,4		;SELECT READ ROW, COLUMN OPTION OF @VDCTL
	LD	A,15		;@VDCTL SVC
	RST	28H		;GET THE ROW IN HL
	INC	H		;CHECK FOR ZERO
	DEC	H
	LD	E,'A'		;VERTICAL TAB FUNCTION IF NOT AT TOP
	JR	NZ,VT52		;GO DO A UP ARROW IF NOT AT TOP
	LD	HL,SCRBUF	;WHERE TO PUT THE SCREEN
	LD	A,15		;@VDCTL SVC
	LD	B,6		;SELECT READ SCREEN OPTION
	RST	28H		;GET THE SCREEN
	LD	HL,SCRBUF-80	;BACK UP 80 FOR BACK SCROLL
	LD	A,15		;@VDCTL SVC
	LD	B,5		;SELECT WRITE SCREEN OPTION
	RST	28H		;WRITE IT
	LD	A,14		;TURN THE CURSOR BACK ON CODE IN A
	CALL	CONOUT		;PRINT IT
	RET
;ENTRY POINT FOR INTERUPT DRIVEN RECEIVE CHARACTER ROUTINE.
GETINT	JR	NZ,GTIN10	;NO CHARACTER AVAILABLE
	LD	HL,(CURCHR)	;CURRENT POS IN BUFFER
	LD	(HL),C		;CHARACTER IS IN C, STORE IT
	INC	L		;POINT TO NEXT WRITE POSITION
	LD	A,(NXTCHR)	;CHECK FOR OVERFLOW
	CP	L		;IS NEXT CHARACTER THE START OF READ
	JR	Z,GTIN10	;FORGET IT AND JUST GO IF SO
	LD	(CURCHR),HL	;SAVE ADDRESS OF NEXT STORE
	LD	A,(INCNT)	;GET HOW MANY CHARACTERS
	INC	A		;ADD ONE TO THE COUNT
	LD	(INCNT),A	;SAVE IT AWAY
	CP	180		;ARE WE GETTING CLOSE TO OVERFLOW
	JP	C,GTIN10	;JUMP IF NOT YET
	LD	A,(FLOFLG)	;ARE WE DOING FLOW CONTROL?
	OR	A
	JR	Z,GTIN10	;GO IF NOT
	LD	A,C		;GET THE CHARACTER JUST RECEIVED
	CP	XOFF		;TIME TO STOP TRANSMITTION?
	JR	NZ,GTIN05	;GO IF NOT
	LD	(XOFREC),A	;SET THE FLAG
	JR	GTIN07		;SAVE A FEW INSTRUCTIONS IF POSSIBLE
GTIN05	CP	XON		;TIME TO START BACK UP?
	JR	NZ,GTIN07
	XOR	A
	LD	(XOFREC),A
GTIN07	LD	A,(XFFLG)	;SEE IF WE ALREADY SENT IT
	OR	A
	JR	NZ,GTIN10	;GO IF WE DID ALREADY SEND XOFF
	INC	A		;MAKE IT NON-ZERO
	LD	(XFFLG),A	;SET IT
	LD	E,XOFF		;SEND THE XOFF
	CALL	OUTCHR		;SENT IT OUT
GTIN10	RET
;LOG THE CHARACTER IN THE LOG FILE
LOGIT	PUSH	AF
	LD	A,(LOGFLG)
	CP	2
	JR	NZ,LOGITO
	POP	AF		;get the character back
	PUSH	AF
	PUSH	DE		;SAVE THE REGS
	LD	DE,LFCB		;GET THE FILE FCB
LOGT1	CALL	XPUT		;@PUT SVC
	JR	Z,LOGEXT	;EXIT IF NO ERRORS
LOGT2	CALL	XERROR		;PRINT THE MESSAGE IN A
	LD	DE,LFCB		;GET THE FCB
	CALL	XCLOSE		;CLOSE THE FILE
	LD	DE,ERMS20	;PRINT A MESSAGE SAYING WE CLOSED IT
	CALL	PRTSTR
	XOR	A		;RESET THE LOG TO FILE FLAG
	LD	(LOGFLG),A	;RESET
LOGEXT	POP	DE
LOGITO	POP	AF
	RET
;	SVC DEFINITIONS
XGET	LD	A,3		;@GET SVC
SVC	RST	28H		;CALL AN SVC
	RET			;RETURN TO THE CALLER
; SVC'S THAT REQUIRE THE CHARACTER PASSED IN A TO BE IN C SHOULD 
; LOOK LILKE THIS.
XPUT	PUSH	BC		;SAVE BC
	PUSH	AF		;SAVE AF
	LD	C,A
	LD	A,4		;@PUT SVC
SVCSAV	RST	28H		;CALL AN SVC
	POP	BC		;POPPING BC DOES NOT AFFECT THE FLAGS
	LD	A,B		;B HAS OLD A SO RESTORE
	POP	BC		;GET OLD BC
	RET			;RETURN TO THE CALLER
XKBD	LD	A,8		;@KBD SVC
	JR	SVC		;GO CALL IT
XKEY	LD	A,1		;@KEY SVC
	JR	SVC		;GO CALL IT
XEXIT	LD	L,A		;A HAS OUR RETURN CODE
	LD	H,0		;MAKE HL THE RETURN CODE
	LD	A,22		;@EXIT SVC
	JR	SVC		;GO CALL IT (NO RETURN)
XERROR	PUSH	BC		;SAVE BC AND AF
	PUSH	AF
	LD	IY,(FLAGS)	;GET @FLAGS ADDRESS
	RES	6,(IY+2)		;RESET ALL SPECIAL BITS
	RES	7,(IY+2)
	RES	6,(IY+18)
	OR	0C0H		;MAKE SIMPLE MESSAGES
	LD	C,A		;C NEEDS THE ERROR NUMBER
	LD	A,CR		;NEED A NEW LINE TO PRINT MESSAGES ON
	CALL	CONOUT
	LD	A,26		;@ERROR SVC   (ISSUE A SYSTEM MESSAGE)
	JR	SVCSAV		;GO CALL IT
XFSPEC	LD	A,78		;@FSPEC SVC   (CREATE A VALID FSPEC)
	JR	SVC		;GO CALL IT
XINIT	LD	A,58		;@INIT SVC    (INITIALIZE A FILE)
	JR	SVC		;GO CALL IT
XOPEN	LD	A,59		;XOPEN SVC    (OPEN A FILE)
	JR	SVC		;GO CALL IT
XCLOSE	LD	A,60		;@CLOSE SVC   (CLOSE A FILE)
	JR	SVC		;GO CALL IT
XKILL	LD	A,57		;@REMOVE SVC  (REMOVE A FILE)
	JR	SVC		;GO CALL IT
XVER	LD	A,73		;@VER SVC (WRITE WITH A VERIFY)
	JR	SVC
XPRT	PUSH	BC
	PUSH	AF
	LD	C,A
	LD	A,6
	JR	SVCSAV
XVDCTL	LD	A,15
	JR	SVC
; THIS ROUTINE SETS UP A TASK IN SLOT 11 TO GENERATE A TONE FROM THE
; SPEAKER.  THIS TASK RUNS CONTINUALLY, AND THE VALUE IN "BEPLEN" TELLS
; THE CODE AT "SOUND" WHETHER OR NOT TO ISSUE THE TONE.
SETINT  LD      DE,INSTAL		;GET THE ADDRESS OF THE ROUTINE
        LD      C,11		;TASK SLOT 11
        LD      A,29		;@ADTSK SVC
        RST     28H		;CALL IT
; THIS CODE SETS UP THE INTERRUPT DRIVEN RECEIVER.  IT CALLS @CTL TO
; PASS THE ADDRESS OF THE "GETINT" ROUTINE WHICH DOES THE PROCESSING.
        LD      A,5		;@CTL SVC
        LD      IY,GETINT	;WHERE TO TRANSFER CONTROL TO
        LD      DE,(CLDCB)	;WHICH DEVICE TO GET
        LD      C,4		;CTL FUNCTION 4
        RST     28H		;CALL IT
	LD	DE,0		;FIND A NEW DCB
	LD	A,82		;@GTDCB SVC
	RST	28H
	JR	NZ,NODCB	;ABORT ON AN ERROR
	LD	(FOTDCB),HL	;POINT AT THE DCB
	PUSH	HL
	POP	IX
	LD	(IX+6),'F'	;SET UP THE FILE OUTPUT DCB
	LD	(IX+7),'O'
	LD	A,2		;SELECT @PUT CAPABILITIES ONLY
	LD	(IX),A
	LD	HL,FILOUT	;GET THE ADDRESS OF THE DRIVER
	LD	(IX+1),L	;STORE THE ADDRESS AWAY
	LD	(IX+2),H
	LD	DE,0		;FIND A NEW DCB FOR INPUT
	LD	A,82		;@GTDCB SVC
	RST	28H
	JR	NZ,NODCB	;ABORT ON AN ERROR
	LD	(FINDCB),HL	;POINT AT THE DCB
	PUSH	HL
	POP	IX
	LD	(IX+6),'F'	;SET UP THE FILE INPUT DCB
	LD	(IX+7),'I'
	LD	A,1		;SELECT @GET CAPABILITIES ONLY
	LD	(IX),A
	LD	HL,FILIN	;GET THE ADDRESS OF THE DRIVER
	LD	(IX+1),L	;STORE THE ADDRESS AWAY
	LD	(IX+2),H
        RET			;RETURN
NODCB	LD	DE,NONDCB
	CALL	PRTSTR
	LD	A,1
	OR	A
	RET
NONDCB	DB	CR,'Can not find a DCB for the *FI or *FO devices!',CR,'$'
INSTAL  DEFW    SOUND		;DATA FOR THE @ADTSK CALL
; TASK 11 COMES TO HERE AND CHECKS "BEPLEN".  IF IT IS ZERO, IT MERELY
; RETURNS TO THE SYSTEM.  IF IT IS NONE-ZERO, THAN THE SOUND IS ISSUED,
; AND "BEPLEN" IS DECREMENTED BY ONE, AND THAN CONTROL IS RETURNED TO THE
; SYSTEM.
SOUND   LD      A,(BEPLEN)	;GET THE VALUE OF THE COUNTER
        OR      A		;CHECK IT FOR ZERO
        RET     Z		;RETURN IF IT IS
	DEC	A		;ONE LESS TIME TO GO
	LD	(BEPLEN),A	;SAVE IT FOR LATER
        LD      A,(SNDST)	;GET THE PORT STATUS
        LD      H,A		;SAVE IT FOR LATER
        XOR     1		;INVERT THE STATUS
        LD      L,A		;SAVE THAT TOO
        OUT     (90H),A		;OSILLATE THE PORT ONCE.
        LD      A,(TIME)	;GET THE BETWEEN OSILLATION TIME
        LD      C,A		;SAVE IT FOR LATER
        LD      B,A		;GET READY TO WAIT
        DJNZ    $		;WAIT!!
        LD      A,H		;GET THE OLD STATUS.
        OUT     (90H),A		;SEND IT OUT
        LD      B,C		;GET THE DELAY AGAIN
        SLA     B		;MAKE IT TIMES 2 THIS TIME
        DJNZ    $		;WAIT FOR A WHILE
        LD      A,L		;GET THE NEXT PORT VALUE
        OUT     (90H),A		;OSSILLATE IT
        LD      B,C		;GET THE DELAY AGAIN
        SLA     B		;TIMES 2 AGAIN
        DJNZ    $		;WAIT FOR AWHILE
        LD      A,H		;GET THE ORIGINAL PORT VALUE
        OUT     (90H),A		;SEND IT OUT
        LD      B,C		;GET THE DELAY
        DJNZ    $		;WAIT
        LD      A,L		;ONE LAST TIME
        OUT     (90H),A		;OUTPUT IT
        LD      (SNDST),A	;SAVE THE INVERSE AS THE NEW FOR NEXT TIME
        RET			;RETURN TO THE CALLER
NEWLIN	PUSH	AF
	LD	A,CR
	CALL	CONOUT
	POP	AF
	RET
SETDSK	LD	A,CMNUM		;PARSE A NUMBER
	CALL	COMND
	JP	KERMT3
	OR	A		;CHECK FOR NO NUMBER
	JP	Z,KERMT2
	LD	A,D		;CHECK FOR OVERFLOW
	OR	A
	JR	NZ,NODRV		;SAY BAD NUMBER
	LD	C,E		;GET THE ACTUAL NUMBER
	LD	A,33		;@CHKDRV SVC
	RST	28H		;DO IT
	JR	NZ,NODRV	;GO ON AN ERROR
	LD	A,C		;GET THE BINARY BACK
	ADD	A,48		;MAKE IT AN ASCII DIGIT
	LD	(DEFDSK),A	;SAVE IT AWAY
	JP	KERMIT		;GET A NEW COMMAND
NODRV	LD	A,32		;ALWAYS SAY ILLEAGAL DRIV NUMBER
	CALL	XERROR		;PRINT THE MESSAGE
	JP	KERMIT		;GET A NEW COMMAND
;	CLEAR THE INPUT BUFFER
CLRPRT	PUSH	AF
	LD	A,(NXTCHR)	; SET NEXT AND CURRENT TO SAME ADDRESS
	LD	(CURCHR),A
	XOR	A		; SET COUNT TO NONE
	LD	(INCNT),A
	LD	(XOFREC),A	; SAY NO XOFF SEEN YET.
	LD	(XFFLG),A	; HAVEN'T SENT XOFF YET EITHER.
	POP	AF
	RET
NOTIMP	DB	CR,16,'Not Implemented as a command.'
	DB	'  Use the SETCOM command!',17,CR,'$'
BAUD	EQU	$
IBMSET	EQU	$
PARSET	EQU	$
	LD	DE,NOTIMP
	CALL	PRTSTR
	JP	KERMIT
;GET A DIRECTORY FOR A DRIVE
DIR	LD	A,CMTXT		;GET A DRIVE NUMBER
	LD	DE,DIRBUF	;GET SOME TEXT
	CALL	COMND		;GET THE USERS INPUT
	JP	KERMT3		;DO DIR (DEFDSK) ON ERROR
	OR	A
	JR	NZ,DIR1C
DIR1B	LD	A,(DEFDSK)	;GET THE USERS DEFAULT DRIVE
	LD	(DIRBUF),A
	PUSH	AF
	LD	A,CR
	LD	(DIRBUF+1),A
	POP	AF
	SUB	48		;MAKE IT A BINARY VALUE	
	LD	C,A		;C IS DRIVE NUMBER
	LD	A,33		;@CHKDRV SVC
	RST	28H		;CALL IT
	JP	NZ,DIRERR	;REPORT AN ERROR
DIR1C	CALL	NEWLIN
	CALL	NEWLIN
	LD	IY,(FLAGS)	;CHECK FOR 6.1 OR 6.2
	LD	A,(IY+27)	;GET THE VERSION
	AND	0FH		;KEEP JUST THE X OF 6.X
	LD	HL,DO62DR
	CP	2
	JR	Z,DIR1E
	LD	HL,DO61DR
DIR1E	LD	DE,DIRCMD
	LD	BC,4
	PUSH	DE
	LDIR
	POP	HL
	LD	A,25		;@CMNDR SVC
	RST	28H
DIR1D	JP	ERA3		;EXIT
DO62DR	DB	'CAT '
DO61DR	DB	'DIR '
DIRCMD	DS	4
DIRBUF	DS	256
DIRERR	CALL	XERROR		;REPORT THE ERROR
	JR	ERA3
;KILL A TRS-80 FILE
ERA	LD     A,CMTXT		; PARSE A FILE-SPEC
	LD     DE,MFNBUF	; INTO FCB
	CALL   COMND
	JP	KERMT3
	OR	A
	JR	Z,ERA3
	LD	HL,MFNBUF
	LD	(MFNPTR),HL
ERA2	CALL	MFNAME		;GET A NEW FILE NAME IN THE BUFFER
	JR	C,ERA3A
	LD	DE,MFREQ
	LD	B,0
	CALL	XOPEN
	JR     Z,ERA1		; FOUND IT
ERA0	CALL	XERROR		; ISSUE THE MESSAGE IN A
	JP	KERMIT		;NEW COMMAND	
ERA1	LD	DE,MFREQ
	CALL	XKILL
	JR	NZ,ERA0
	LD     DE,INMS18	;" FILE KILLED"
	CALL   PRTSTR
	JR	ERA2
ERA3A	CALL	C,NEWLIN	;ONLY IF KILLED AT LEAST ONE FILE
ERA3	JP     KERMIT
;	PRINT ESCAPE CHARACTER SEQUENCE CONTROL - ?
ESCPR	LD     A,(ESCCHR)		; GET THE ESCAPE CHAR.
ESCPR1	CP     ' '		; IS IT A CONTROL CHAR?
	JP     P,ESCPR2
	PUSH	AF
	LD     DE,INMS10	; OUTPUT "CONTROL-"
	CALL   PRTSTR
	POP	AF		;GET THE CHAR BACK
	OR     100O		; DE-CONTROLIFY.
ESCPR2	CALL	CONOUT
	LD	A,20H
	CALL	CONOUT
	RET    
;
;	*FI DEVICE DRIVER IS HERE.
;
FILIN	JR	INPFIL
	DW	ENDIN
	DB	4
	DB	'INP$'
FINDCB	DW	0
	DW	0
PRECHR	DB	0
INPFIL	CALL	INPORT
	JR	Z,INP04
	CALL	CONIN
	OR	A
	JR	Z,INPFIL
	CP	128
	JR	NZ,INP03
	LD	A,28		;RETURN WE ARE AT END OF FILE
	OR	A
	RET
INP03	LD	E,A
	CALL	OUTCHR
	JR	INPFIL
INP04	LD	C,A
	LD	A,(FLOFLG)	;ARE WE DOING FLOW CONTROL
	CP	1		;IS IT XON/XOFF
	JR	NZ,INP05
	LD	A,C
	CP	XON
	JR	Z,INPFIL
	CP	XOFF
	JR	Z,INPFIL
INP05	LD	A,(PRECHR)
	CP	CR
	LD	A,C
	JR	NZ,INP09
	CP	LF
	JR	Z,INPFIL	;THROW OUT <LF> AFTER <CR>
INP09	CP	A
	RET
ENDIN	EQU	$
;
;	*FO DEVICE DRIVER IS HERE.
;
FILOUT	JR	FIOUT
	DW	OUTEND-1
	DB	4
	DB	'OUT$'
FOTDCB	DW	0
	DW	0
FIOUT	LD	E,C		;GET THE CHARACTER TO OUTPUT
FIOUT1	CALL	OUTCHR		;SEND IT OUT. WE WILL HANG HERE TILL SENT
	LD	A,C		;GET THE CHARACTER SENT
	CP	A		;SET THE Z FLAG
	RET	
OUTEND	EQU	$

